/***************************************************************************
                          dbcommand.h  -  description
                             -------------------
    begin                : Sun Jan 2 2000
    copyright            : (C) 2000 by Jon Anderson
    email                : janderson@onelink.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DBCOMMAND_H
#define DBCOMMAND_H

#include "entitycommand.h"
#include "../objectdb.h"

/**Performa an action on the Entity and ObjectDB
  *@author Jon Anderson
  */

#define CLEAR  0
#define ADD 1
#define REMOVE 2



class DBCommand : public Command {
public: 
	DBCommand(Entity *e, int command);
	~DBCommand();
	
	bool execute();
	bool undo();	
protected:
	int command;
	Entity *e;
		
};

#endif
