/***************************************************************************
                          entitycommand.h  -  description                              
                             -------------------                                         
    begin                : Sun Dec 5 1999                                           
    copyright            : (C) 1999 by Jon Anderson                         
    email                : janderson@onelink.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef ENTITYCOMMAND_H
#define ENTITYCOMMAND_H

#include "command.h"

class Transformable;

/** An EntityCommand is a abstract class for all commands that manipulate an
  * entity.
  *@author Jon Anderson
  */

class EntityCommand : public Command  {
public: 
	EntityCommand(Transformable *e);
	virtual ~EntityCommand();
	
protected: // Protected attributes
  /** The entity upon which the action should occur. */
 Transformable * e;

};

#endif
