/***************************************************************************
                          movecommand.h  -  description                              
                             -------------------                                         
    begin                : Sun Dec 5 1999                                           
    copyright            : (C) 1999 by Jon Anderson                         
    email                : janderson@onelink.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef MOVECOMMAND_H
#define MOVECOMMAND_H

#include "propertycommand.h"
#include <Entities/entity.h>

/** A move command encapsulates a request to move an entity.
  *@author Jon Anderson
  */

class MoveCommand : public PropertyCommand  {
public: 
	MoveCommand(Transformable *_e, Vector4 &s);
	~MoveCommand();
  /** Move the entity to the old location. */
  bool undo();
  /** Move the entity to the new location. */
  bool execute();
protected:
	Vector4 amount;
	Vector4 oldAmount;
	
	
};

#endif
