/***************************************************************************
                          primitivecommand.h  -  description
                             -------------------                                         
    begin                : Sun Dec 5 1999                                           
    copyright            : (C) 1999 by Jon Anderson                         
    email                : janderson@onelink.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef PRIMITIVECOMMAND_H
#define PRIMITIVECOMMAND_H

#include "command.h"
#include <stdlib.h>

/**This is template class to handle changing
  *primitive data types when it's necessary to undo them.
  *@author Jon Anderson
  */
template <class T>
class PrimitiveCommand :public Command {
public: 
	PrimitiveCommand(T *o, T *n);
	 ~PrimitiveCommand();
  /** Undo's this command */
  bool undo();
  /** Executes the this command */
  bool execute();

  bool save();
private:
	T *oldValue;
	T *newValue;
};

#endif
