/***************************************************************************
                         scalecommand.h  -  description                              
                             -------------------                                         
    begin                : Sun Dec 5 1999                                           
    copyright            : (C) 1999 by Jon Anderson                         
    email                : janderson@onelink.com                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef SCALECOMMAND_H
#define SCALECOMMAND_H

#include "propertycommand.h"
#include <Entities/entity.h>
/** Encapsulates a request to scale an entity.
  *@author Jon Anderson
  */

class ScaleCommand : public PropertyCommand  {
public: 
	ScaleCommand(Transformable *_e, Vector4 &s, Vector4 &p);
	~ScaleCommand();
  /** Undo the scale action. */
  bool undo();
  /** Scale the entity to the new size. */
  bool execute();
protected:
	Vector4 amount;
	Vector4 oldamount;
	Vector4 pt;
};

#endif
