/***************************************************************************
                         cube.h  -  description                              
                            -------------------                                         
   begin                : Wed Aug 4 1999                                           
   copyright            : (C) 1999 by Jon Anderson                         
   email                : janderson@onelink.com                                     
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef CUBE_H
#define CUBE_H

#include "mesh.h"

/**A Cube Object.  This is simply a subclass wrapper for Object which knows how to
construct a cube object.  Cube can be divided into any number of sections in w, h, and depth
 for greater level of detail.
  *@author Jon Anderson
  */

class Cube : public Mesh
{
   public:
      /**Constructs a cube located at x, y, z; */
      Cube( float x = 0, float y = 0, float z = 0, int w = 0, int h = 0, int d = 0 );
      ~Cube();
};

#endif








