/***************************************************************************
                         heightmap.h  -  description
                            -------------------
   begin                : Fri Mar 31 2000
   copyright            : (C) 2000 by Jon Anderson
   email                : janderson@onelink.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HEIGHTMAP_H
#define HEIGHTMAP_H

#include "mesh.h"
#include <qimage.h>

/**
  *@author Jon Anderson
  */

class HeightMap : public Mesh
{
   public:
      HeightMap( float x, float y, float z, float hx, float hy, float hz );
      HeightMap( QImage &i, float x, float y, float z, float hx, float hy, float hz );

      ~HeightMap();
      void loadHeightMap();
      void init( QImage &i );

   protected:
      int x_steps;
      int z_steps;
      int y_size;

};

#endif
