/***************************************************************************
                         bonecreator.h  -  description
                            -------------------
   begin                : Sun Apr 22 2001
   copyright            : (C) 2001 by Jon Anderson
   email                : janderson@onelink.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BONECREATOR_H
#define BONECREATOR_H

#include "creator.h"
#include <qobject.h>


class Bone;

/**
  *@author Jon Anderson
  */

class BoneCreator : public Creator
{
      Q_OBJECT

   public:
      BoneCreator();
      ~BoneCreator();

      virtual void mousePress ( Vector4 &, Vector4 &, int );
      virtual void keyEvent ( QKeyEvent * );

      virtual void activate();
      virtual void deactivate();

      static int TYPE;

   public slots:
      void slotCreateRoot();
      void slotCreateBall();
      void slotCreateXY();
      void slotCreateXZ();
      void slotCreateYZ();
      void slotCreateCustom();

      Bone * m_bone;
};

#endif
