/***************************************************************************
                         bonemodifier.h  -  description
                            -------------------
   begin                : Sun Apr 29 2001
   copyright            : (C) 2001 by Jon Anderson
   email                : janderson@onelink.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BONEMODIFIER_H
#define BONEMODIFIER_H

#include "objectmodifier.h"

/**
  *@author Jon Anderson
  */


class BoneModifier : public ObjectModifier
{
      Q_OBJECT
   public:
      BoneModifier();
      ~BoneModifier();

      virtual void activate();
      virtual void deactivate();

      static int TYPE;

   public slots:
      void slotAddXY();
      void slotAddXZ();
      void slotAddYZ();
      void slotAddBall();

      void slotEnvelope();
      void slotNormal();
      void slotIK();
      void slotLimits();

      void slotSaveAffected();
      void slotSaveAffectedAndOffsets();
      void slotResetAffected();
      void slotSaveOffsets();

      void slotSaveAffectedR();
      void slotSaveAffectedAndOffsetsR();
      void slotResetAffectedR();
      void slotSaveOffsetsR();
      void slotToggleAffected();
      void slotToggleEnvelope();
      void slotToggleLimits();
      void slotProperties();

   protected:

      int draw_affected;
      int draw_envelope;
      int draw_limits;

      int mode_normal;
      int mode_ik;
      int mode_envelope;
      int mode_limits;


};

#endif
