/***************************************************************************
                          psurfacedlg.h  -  description
                             -------------------
    begin                : Wed Nov 7 2001
    copyright            : (C) 2001 by Jon Anderson
    email                : janderson@onelink.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PSURFACEDLG_H
#define PSURFACEDLG_H

#include <qwidget.h>
#include <ipsurfacedlg.h>
#include <string>

class NurbsSurface;
class Vector4;
class Quat;

/**
  *@author Jon Anderson
  */

class PSurfaceDlg : public IPSurfaceDlg  {
   Q_OBJECT
public: 
	PSurfaceDlg(QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~PSurfaceDlg();
	
	    void setEnableAll( bool );
	
	    void setSurface( NurbsSurface * );

      string getName();
      string getNotes();
      Vector4 getPosition();
      Quat getOrientation();

   public slots:
      void slotApply();
      void slotAccept();
};

#endif
