/***************************************************************************
                         subobjectmodifier.h  -  description
                            -------------------
   begin                : Sun Apr 22 2001
   copyright            : (C) 2001 by Jon Anderson
   email                : janderson@onelink.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SUBOBJECTMODIFIER_H
#define SUBOBJECTMODIFIER_H

#include "modifier.h"

class Mesh;

/**
  *@author Jon Anderson
  */

class SubObjectModifier : public Modifier
{
      Q_OBJECT

   public:
      SubObjectModifier( int type );
      virtual ~SubObjectModifier();

      Mesh * getSubObjectParent();
      vector<int> SubObjectModifier::getSubObjectList();
      bool assertSameParent();

      virtual void startTransform();
      virtual void endTransform();

      virtual void activate() = 0;
      virtual void deactivate() = 0;

      virtual void copy();
      virtual void paste();
      virtual void cut();



};

#endif
