/***************************************************************************
                         surfacecreator.h  -  description
                            -------------------
   begin                : Thu Apr 19 2001
   copyright            : (C) 2001 by Jon Anderson
   email                : janderson@onelink.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SURFACECREATOR_H
#define SURFACECREATOR_H

#include "creator.h"
#include <qobject.h>

class NurbsSurface;
/**
  *@author Jon Anderson
  */

class SurfaceCreator : public Creator
{
      Q_OBJECT

   public:
      SurfaceCreator();
      ~SurfaceCreator();

      virtual void mousePress ( Vector4 &, Vector4 &, int );
      virtual void keyEvent ( QKeyEvent * );

      virtual void activate();
      virtual void deactivate();

      static int TYPE;

   public slots:
      void slotCreateSphere();
      void slotCreateTorus();
      void slotCreateXYPatch();
      void slotCreateXZPatch();
      void slotCreateYZPatch();
      void slotCreateCustom();

   private:
      NurbsSurface *m_surface;
};

#endif
