/***************************************************************************
                         vertexmodifier.h  -  description
                            -------------------
   begin                : Sat Apr 21 2001
   copyright            : (C) 2001 by Jon Anderson
   email                : janderson@onelink.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VERTEXMODIFIER_H
#define VERTEXMODIFIER_H

#include "subobjectmodifier.h"

/**
  *@author Jon Anderson
  */

class VertexModifier : public SubObjectModifier
{

      Q_OBJECT

   public:
      VertexModifier();
      ~VertexModifier();



      virtual void activate();
      virtual void deactivate();
      virtual void selectionEvent();

      static int TYPE;

      void gridSnap( Vector3 & );

   public slots:
      void slotSnap();
      void slotWeld();
      void slotGridSnapX();
      void slotGridSnapZ();
      void slotGridSnapY();
      void slotGridSnapAll();
      void slotExtrude();
      void slotConnect();
      void slotLoop();
      void slotBevel();
      void slotDelete();
      void slotCreateFace();
      void slotSetColor();
      void slotResetColor();
      /** No descriptions */
      void slotUnhideAll();
      /** Hides currently selected cp's. */
      void slotHideSelected();

};

#endif
