/***************************************************************************
                         glmdiview.h  -  description
                            -------------------
   begin                : Fri Jan 14 2000
   copyright            : (C) 2000 by Jon Anderson
   email                : janderson@onelink.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLMDIVIEW_H
#define GLMDIVIEW_H

#include <MDI/qextmdichildview.h>
#include <qlayout.h>

class GLView;

/**This class is an Mdi Child View widget that contains an
GLView.
  *@author Jon Anderson
  */


class GLMdiView : public QextMdiChildView
{
   public:
      GLMdiView( char *caption, QWidget *_p );
      void setView( GLView *v ); //{view = v;};
      ~GLMdiView();

      void updateGL();
      GLView * getView() { return view;};

   protected:

      void keyPressEvent( QKeyEvent *event );
      void keyReleaseEvent( QKeyEvent *event );
      void resizeEvent( QResizeEvent * );

   protected:
      GLView *view;
      QGridLayout *layout;
};

#endif
